<template>
  <div :id="id" :class="className" :style="{height:height,minWidth:width}" />
</template>

<script>
import echarts from 'echarts'
import resize from './mixins/resize'

export default {
  mixins: [resize],
  props: {
    className: {
      type: String,
      default: 'chart'
    },
    id: {
      type: String,
      default: 'chart'
    },
    title: {
      type: String,
      default: 'line'
    },
    width: {
      type: String,
      default: '500px'
    },
    height: {
      type: String,
      default: '400px'
    },
    lineData: {
      type: Object,
      default: () => {
        return {
          xAxis: [],
          series: []
        }
      }
    },
    description: {
      type: String,
      default: ''
    },
    config: {
      type: Object,
      default: () => {
        return {}
      }
    },
    format: {
      type: String,
      default: 'HH:mm:ss'
    },
    step: {
      type: Boolean,
      default: false
    }
  },
  data() {
    return {
      chart: null
    }
  },
  watch: {
    lineData: function(val) {
      this.updateChart(val)
    }
  },
  mounted() {
    this.initChart()
  },
  beforeDestroy() {
    if (!this.chart) {
      return
    }
    this.chart.dispose()
    this.chart = null
  },
  methods: {
    updateChart(data) {
      this.chart.setOption({
        xAxis: {
          data: data.xAxis
        },
        series: [{
          type: 'line',
          showSymbol: false,
          clip: true,
          data: data.series.map(v => this.strip(v))
        }]
      })
    },
    strip(num, precision = 12) {
      return +parseFloat(num.toPrecision(precision))
    },
    initChart() {
      function strip(num, precision = 12) {
        return +parseFloat(num.toPrecision(precision))
      }
      const lineData = {
        xAxis: [],
        series: []
      }
      for (let i = 0; i < 1; i += 0.001) {
        const number = strip(i)
        lineData.xAxis.push(number)
        lineData.series.push(Math.sin(2 * Math.PI * number))
      }
      this.chart = echarts.init(document.getElementById(this.id))
      let config = {
        tooltip: {},
        xAxis: {
          data: []
        },
        yAxis: {},
        series: [{
          type: 'line',
          data: []
        }]
      }
      config = {
        ...config,
        ...this.config
      }

      this.chart.setOption(config)
    }
  }
}
</script>
